--[[ ---------------------------------------------------------------------------

BuffEnough: personal buff monitor.

BuffEnough is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

BuffEnough is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with BuffEnough.  If not, see <http://www.gnu.org/licenses/>.

----------------------------------------------------------------------------- ]]

if select(2, UnitClass("player")) ~= "WARLOCK" then return end 

local L = LibStub("AceLocale-3.0"):GetLocale("BuffEnough")
local Warlock = BuffEnough:GetOrCreateModule("Player")

BuffEnough.options.args.pet.guiHidden = false


--[[ ---------------------------------------------------------------------------
     Check class buffs
----------------------------------------------------------------------------- ]]
function Warlock:CheckClassBuffs()

    if BuffEnough.debug then BuffEnough:debug("Checking warlock buffs") end

    BuffEnough:TrackItem(L["Buffs"], BuffEnough.spells["Fel/Demon Armor"], false, true, false, nil, nil, true)
    BuffEnough:TrackItem(L["Buffs"], BuffEnough.spells["Dark Intent"], false, true, false, nil, nil, true, nil, nil, true)
    if not IsMounted() then
       if not UnitExists("pet") then
	  BuffEnough:TrackItem(L["Pet"], L["Pet"], false, true, false, nil, nil, true)
       end
    else
       BuffEnough:TrackItem(L["Pet"], L["Pet"], true, false, false, nil, nil, true)
    end
    
    self:CheckPetBuffs()
end
